package com.napa.pulse.dao.impl;

import org.junit.Test;
import org.junit.jupiter.api.BeforeEach;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.test.util.ReflectionTestUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.mockito.ArgumentMatchers.anyInt;
import static org.mockito.ArgumentMatchers.anyString;
import static org.mockito.Mockito.when;

/**
 * @author Aqueel Ahmad
 * 13/9/2022
 */
@SpringBootTest
@RunWith ( MockitoJUnitRunner.class )
public class CommomDAOImplUnitTest {
    @Mock
    JdbcTemplate jdbcTemplate;

    @InjectMocks
    CommonDAOImpl mockCommonDAOImpl;

    @BeforeEach
    public void setup ( ) {
        MockitoAnnotations.initMocks(this);
    }

    @Test
    public void test_getBlueBarTotalsParameter ( ) {
        List<Map<String, Object>> expected = new ArrayList<>();
        Map<String, Object> resultMap = new HashMap<>();
        expected.add(resultMap);
        ReflectionTestUtils.setField(mockCommonDAOImpl, "jdbcTemplate", jdbcTemplate);
        int siteId = 1246;
        when(jdbcTemplate.queryForList(anyString(), anyInt())).thenReturn(expected);
        List<Map<String, Object>> result = mockCommonDAOImpl.getBlueBarTotalsParameter(siteId, 0);
        assertEquals(1, result.size());
        assertNotNull(result);

    }

    @Test
    public void test_getBlueBarTotalsParameter2 ( ) {
        List<Map<String, Object>> expected = new ArrayList<>();
        Map<String, Object> resultMap = new HashMap<>();
        expected.add(resultMap);
        ReflectionTestUtils.setField(mockCommonDAOImpl, "jdbcTemplate", jdbcTemplate);
        int siteId = 1246;
        when(jdbcTemplate.queryForList(anyString(), anyInt())).thenReturn(expected);
        //List<Map<String, Object>> result = mockCommonDAOImpl.getBlueBarTotalsParameter(siteId, 279303);
        //assertEquals(0, result.size());
        //assertNotNull(result);

    }

    @Test
    public void test_getUserLanguage ( ) {
        List<Map<String, Object>> expected = new ArrayList<>();
        Map<String, Object> resultMap = new HashMap<>();
        expected.add(resultMap);
        ReflectionTestUtils.setField(mockCommonDAOImpl, "jdbcTemplate", jdbcTemplate);
        int uerId = 1;
        when(jdbcTemplate.queryForList(anyString(), anyInt())).thenReturn(expected);
        List<Map<String, Object>> result = mockCommonDAOImpl.getUserLanguage(uerId);
        assertEquals(1, result.size());
        assertNotNull(result);
    }
}
