package com.napa.pulse.dao.impl;

import com.napa.pulse.dao.interfaces.SessionDAO;
import com.napa.pulse.dto.ProductGroupHierarchy;
import com.napa.pulse.exception.PulseException;
import com.napa.pulse.service.interfaces.CommonService;
import com.napa.pulse.utils.SiteQueueMap;
import com.opencsv.ResultSetHelper;
import io.swagger.models.auth.In;
import org.junit.Before;
import org.junit.Test;
import org.junit.jupiter.api.BeforeEach;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.ResultSetExtractor;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.test.util.ReflectionTestUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import static org.assertj.core.api.Assertions.assertThat;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;
import static org.mockito.ArgumentMatchers.*;
import static org.mockito.Mockito.mock;
import static org.mockito.Mockito.when;
import static org.mockito.MockitoAnnotations.initMocks;

/**
 * @author Aqueel Ahmad
 * 24/8/2022
 */
@SpringBootTest
@RunWith ( MockitoJUnitRunner.class )
public class ParametersDAOImplUnitTest {
    @InjectMocks
    ReviewDAOImpl mockReviewDAO;
    @Mock
    CommonService commonService;
    @Mock
    JdbcTemplate jdbcTemplate;
    @InjectMocks
    SiteQueueMap mockSiteQueueMap;
    @Mock
    SessionDAO sessionDAO;
    @Mock
    ParametersDAOImpl mockParameterDAO;
    @Mock
    ProductGroupHierarchy mockProductGroupHierarchy;

    @Before
    public void setUp ( ) {
        initMocks(this);
        jdbcTemplate = mock(JdbcTemplate.class);
    }

@Test
    public void test_canStart (  ) {
        mockSiteQueueMap.canStart(1246, "linkToParent");
    }

    @Test
    public void test_removeHead (  ) {
        mockSiteQueueMap.removeHead(1246, "linkToParent");
    }

}
